Creating the table tree
The widget allows displaying data in a hierarchical format with collapsible rows.
Creating a tree structure
To create a tree structure, do the following:
- prepare a valid dataset for the tree table using the
columnsanddataproperties - set the
treeproperty value to true - set the
treetoggleparameter of some column in thecolumnsproperty to true - for initially closed branches set the
openparameter of a data item tofalse
Example:
<script setup>
import { Grid } from "@svar-ui/vue-grid";
const treeColumns = [
{ id: "id", width: 80 },
{
id: "lastName",
header: "Last Name",
flexgrow: 1,
treetoggle: true,
},
{ id: "firstName", header: "First Name" },
{ id: "city", width: 100, header: "City" },
];
const treeData = [
{
id: 1,
city: "Amieshire",
firstName: "Ernest",
lastName: "Schuppe",
open: false,
data: [
{
id: "1.1",
city: "Gust",
firstName: "Janis",
lastName: "Vandervort",
},
{
id: "1.2",
city: "Amieshire",
firstName: "Makenzie",
lastName: "Bode",
},
],
},
{
id: 2,
city: "Amieshire",
firstName: "Ciara",
lastName: "Towne",
data: [
{
id: "2.1",
city: "Amieshire",
firstName: "Suzanne",
lastName: "Wolff",
},
{
id: "2.2",
city: "Amieshire",
firstName: "Alessandra",
lastName: "Feeney",
},
],
},
];
</script>
<template>
<Grid :tree="true" :data="treeData" :columns="treeColumns" />
</template>
Collapsing/expanding all rows at a time
To collapse or expand all rows, apply the open-row and close-row actions and set the id value to 0, and the nested value to true. In the example below we make all rows expand/collapse on a button click. To do this, we get access to the Grid api via the ref construct and use the api.exec() method to trigger the open-row and close-row actions with a button click.
Example:
<script setup>
import { ref } from "vue";
import { Button } from "@svar-ui/vue-core"; // import the Button component
import { getData } from "./common/data";
import { Grid } from "@svar-ui/vue-grid";
const { treeData, treeColumns } = getData();
const api = ref(null);
function openAll() {
api.value.exec("open-row", { id: 0, nested: true });
}
function closeAll() {
api.value.exec("close-row", { id: 0, nested: true });
}
</script>
<template>
<div class="toolbar">
<Button type="primary" :onclick="() => openAll()">Open all</Button>
<Button type="primary" :onclick="() => closeAll()">Close all</Button>
</div>
<Grid ref="api" :tree="true" :data="treeData" :columns="treeColumns" />
</template>
Related sample: Tree structure
Related articles: How to access Grid API

Skip to main content

Creating the table tree

The widget allows displaying data in a hierarchical format with collapsible rows.

Creating a tree structure

To create a tree structure, do the following:

  • prepare a valid dataset for the tree table using the columns and data properties
  • set the tree property value to true
  • set the treetoggle parameter of some column in the columns property to true
  • for initially closed branches set the open parameter of a data item to false

Example:

import { Grid } from "@svar-ui/react-grid";

const treeColumns = [
{ id: "id", width: 80 },
{
id: "lastName",
header: "Last Name",
flexgrow: 1,
treetoggle: true,
},
{ id: "firstName", header: "First Name" },
{ id: "city", width: 100, header: "City" },
];

const treeData = [
{
id: 1,
city: "Amieshire",
firstName: "Ernest",
lastName: "Schuppe",
open: false,
data: [
{
id: "1.1",
city: "Gust",
firstName: "Janis",
lastName: "Vandervort",

},
{
id: "1.2",
city: "Amieshire",
firstName: "Makenzie",
lastName: "Bode",
},
],
},
{
id: 2,
city: "Amieshire",
firstName: "Ciara",
lastName: "Towne",
data: [
{
id: "2.1",
city: "Amieshire",
firstName: "Suzanne",
lastName: "Wolff",
},
{
id: "2.2",
city: "Amieshire",
firstName: "Alessandra",
lastName: "Feeney",
},
],
},
];

export default function TreeExample() {
return <Grid tree={true} data={treeData} columns={treeColumns} />;
}

Collapsing/expanding all rows at a time

To collapse or expand all rows, apply the open-row and close-row actions and set the id value to 0, and the nested value to true. In the example below we make all rows expand/collapse on a button click. To do this, get access to the Grid API via a React ref and use the api.exec() method to trigger the open-row and close-row actions with a button click.

Example:

import { useRef } from "react";
import { Button } from "@svar-ui/react-core"; // import the Button component
import { getData } from "./common/data";
import { Grid } from "@svar-ui/react-grid";

const { treeData, treeColumns } = getData();

export default function TreeControlExample() {
const apiRef = useRef(null);

function openAll() {
apiRef.current?.exec("open-row", { id: 0, nested: true });
}

function closeAll() {
apiRef.current?.exec("close-row", { id: 0, nested: true });
}

return (
<>
<div className="toolbar">
<Button type="primary" onClick={() => openAll()}>Open all</Button>
<Button type="primary" onClick={() => closeAll()}>Close all</Button>
</div>

<Grid ref={apiRef} tree={true} data={treeData} columns={treeColumns} />
</>
);
}

Related sample: Tree structure

Related articles: How to access Grid API

Skip to main content

Creating the table tree

The widget allows displaying data in a hierarchical format with collapsible rows.

Creating a tree structure

To create a tree structure, do the following:

  • prepare a valid dataset for the tree table using the columns and data properties
  • set the tree property value to true
  • set the treetoggle parameter of some column in the columns property to true
  • for initially closed branches set the open parameter of a data item to false

Example:

<script>
import { Grid } from "@svar-ui/svelte-grid";

const treeColumns = [
{ id: "id", width: 80 },
{
id: "lastName",
header: "Last Name",
flexgrow: 1,
treetoggle: true,
},
{ id: "firstName", header: "First Name" },
{ id: "city", width: 100, header: "City" },
];

const treeData = [
{
id: 1,
city: "Amieshire",
firstName: "Ernest",
lastName: "Schuppe",
open: false,
data: [
{
id: "1.1",
city: "Gust",
firstName: "Janis",
lastName: "Vandervort",

},
{
id: "1.2",
city: "Amieshire",
firstName: "Makenzie",
lastName: "Bode",
},
],
},
{
id: 2,
city: "Amieshire",
firstName: "Ciara",
lastName: "Towne",
data: [
{
id: "2.1",
city: "Amieshire",
firstName: "Suzanne",
lastName: "Wolff",
},
{
id: "2.2",
city: "Amieshire",
firstName: "Alessandra",
lastName: "Feeney",
},
],
},
];
</script>

<Grid tree={true} data={treeData} columns={treeColumns} />

Collapsing/expanding all rows at a time

To collapse or expand all rows, apply the open-row and close-row actions and set the id value to 0, and the nested value to true. In the example below we make all rows expand/collapse on a button click. To do this, we get access to the Grid api via the bind:this construct and use the api.exec() method to trigger the open-row and close-row actions with a button click.

Example:

<script>
import { Button } from "@svar-ui/svelte-core"; // import the Button component
import { getData } from "./common/data";
import { Grid } from "@svar-ui/svelte-grid";

const { treeData, treeColumns } = getData();

let api = $state();

function openAll() {
api.exec("open-row", { id: 0, nested: true });
}

function closeAll() {
api.exec("close-row", { id: 0, nested: true });
}

</script>

<div class="toolbar">
<Button type="primary" onclick={() => openAll()}>Open all</Button>
<Button type="primary" onclick={() => closeAll()}>Close all</Button>
</div>

<Grid bind:this={api} tree={true} data={treeData} columns={treeColumns} />

Related sample: Tree structure

Related articles: How to access Grid API